;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;	current state	;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;	dot option select	;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

.386
.model flat, stdcall
option casemap :none   ; case sensitive

;;;;;;;;;;;;;;;;;;;;
;;;;	include	;;;;
;;;;;;;;;;;;;;;;;;;;

include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\comctl32.inc
include \masm32\include\gdi32.inc

;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;	includelib	;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;

includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\comctl32.lib
includelib \masm32\lib\gdi32.lib

;;;;;;;;;;;;;;;;;;;;
;;;;	macro	;;;;
;;;;;;;;;;;;;;;;;;;;

ret2	MACRO	backtotrue, backtom
		IF	backtotrue NE 0
			mov	backtom, eax
		ENDIF
	ENDM

m2m	MACRO	M1, M2
		push	M2
		pop	M1
	ENDM

return	MACRO	arg
		mov	eax, arg
		ret
	ENDM

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;	win32 Function Macro	;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

win32_GetModuleHandle	MACRO	backtotrue, backtom, lpModuleName
		push	lpModuleName
		call	GetModuleHandle
		ret2	backtotrue,	backtom
	ENDM

win32_GetCommandLine	MACRO	backtotrue, backtom
		call	GetCommandLine
		ret2	backtotrue,	backtom
	ENDM

win32_LoadIcon	MACRO	backtotrue, backtom, hInstance, lpIconName
		push	lpIconName
		push	hInstance
		call	LoadIcon
		ret2	backtotrue,	backtom
	ENDM

win32_LoadCursor	MACRO	backtotrue, backtom, hInstance, lpCursorName
		push	lpCursorName
		push	hInstance
		call	LoadCursor
		ret2	backtotrue,	backtom
	ENDM

win32_RegisterClassEx	MACRO	backtotrue, backtom, _lpwcx
		push	_lpwcx
		call	RegisterClassEx
		ret2	backtotrue,	backtom
	ENDM

win32_CreateWindowEx	MACRO	backtotrue, backtom, dwExStyle, lpClassName, lpWindowName, dwStyle, x, y, nWidth, nHeight, hWndParent, hMenu, hInstance, lpParam
		push	lpParam
		push	hInstance
		push	hMenu
		push	hWndParent
		push	nHeight
		push	nWidth
		push	y
		push	x
		push	dwStyle
		push	lpWindowName
		push	lpClassName
		push	dwExStyle
		call	CreateWindowEx
		ret2	backtotrue,	backtom
	ENDM

win32_ShowWindow	MACRO	backtotrue, backtom, hWnd, nCmdShow
		push	nCmdShow
		push	hWnd
		call	ShowWindow
		ret2	backtotrue,	backtom
	ENDM

win32_UpdateWindow	MACRO	backtotrue, backtom, hWnd
		push	hWnd
		call	UpdateWindow
		ret2	backtotrue,	backtom
	ENDM

win32_GetMessage	MACRO	backtotrue, backtom, lpMsg, hWnd, wMsgFilterMin, wMsgFilterMax
		push	wMsgFilterMax
		push	wMsgFilterMin
		push	hWnd
		push	lpMsg
		call	GetMessage
		ret2	backtotrue,	backtom
	ENDM

win32_TranslateMessage	MACRO	backtotrue, backtom, _lpMsg
		push	_lpMsg
		call	TranslateMessage
		ret2	backtotrue,	backtom
	ENDM

win32_DispatchMessage	MACRO	backtotrue, backtom, _lpMsg
		push	_lpMsg
		call	DispatchMessage
		ret2	backtotrue,	backtom
	ENDM

win32_ExitProcess	MACRO	backtotrue, backtom, uExitCode
		push	uExitCode
		call	ExitProcess
		;	Doesn't return a value
	ENDM

win32_PostQuitMessage	MACRO	backtotrue, backtom, nExitCode
		push	nExitCode
		call	PostQuitMessage
		;	Doesn't return a value
	ENDM

win32_DefWindowProc	MACRO	backtotrue, backtom, hWnd, Msg, wParam, lParam
		push	lParam
		push	wParam
		push	Msg
		push	hWnd
		call	DefWindowProc
		ret2	backtotrue,	backtom
	ENDM

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;	addition win32 Function Macro	;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

win32_InitCommonControls MACRO	backtotrue, backtom
		call	InitCommonControls
		;	Doesn't return a value
	ENDM

win32_ImageList_Create	MACRO	backtotrue, backtom, cx, cy, flags, cInitial, cGrow
		push	cGrow
		push	cInitial
		push	flags
		push	cy
		push	cx
		call	ImageList_Create
		ret2	backtotrue,	backtom
	ENDM

win32_ImageList_Destroy	MACRO	backtotrue, backtom, himl
		push	himl
		call	ImageList_Destroy
		ret2	backtotrue,	backtom
	ENDM

win32_ImageList_Add	MACRO	backtotrue, backtom, himl, hbmImage, hbmMask
		push	hbmMask
		push	hbmImage
		push	himl
		call	ImageList_Add
		ret2	backtotrue,	backtom
	ENDM

win32_ImageList_AddMasked	MACRO	backtotrue, backtom, himl, hbmImage, hbmMask
		push	hbmMask
		push	hbmImage
		push	himl
		call	ImageList_AddMasked
		ret2	backtotrue,	backtom
	ENDM

win32_ImageList_DrawEx	MACRO	backtotrue, backtom, himl, i, hdcDst, x, y, dx, dy, rgbBk, rgbFg, fStyle
		push	fStyle
		push	rgbFg
		push	rgbBk
		push	dy
		push	dx
		push	y
		push	x
		push	hdcDst
		push	i
		push	himl
		call	ImageList_DrawEx
		ret2	backtotrue,	backtom
	ENDM

win32_DeleteObject	MACRO	backtotrue, backtom, hObject
		push	hObject
		call	DeleteObject
		ret2	backtotrue,	backtom
	ENDM

win32_LoadBitmap	MACRO	backtotrue, backtom, hInstance, lpBitmapName
		push	lpBitmapName
		push	hInstance
		call	LoadBitmap
		ret2	backtotrue,	backtom
	ENDM

win32_MessageBox	MACRO	backtotrue, backtom, hWnd, lpText, lpCaption, uType
		push	uType
		push	lpCaption
		push	lpText
		push	hWnd
		call	MessageBox
		ret2	backtotrue,	backtom
	ENDM

win32_BeginPaint	MACRO	backtotrue, backtom, hWnd, lpPaint
		push	lpPaint
		push	hWnd
		call	BeginPaint
		ret2	backtotrue,	backtom
	ENDM

win32_EndPaint	MACRO	backtotrue, backtom, hWnd, _lpPaint
		push	_lpPaint
		push	hWnd
		call	EndPaint
		ret2	backtotrue,	backtom
	ENDM

win32_GetDC	MACRO	backtotrue, backtom, hWnd
		push	hWnd
		call	GetDC
		ret2	backtotrue,	backtom
	ENDM

win32_ReleaseDC	MACRO	backtotrue, backtom, hWnd, hDC
		push	hDC
		push	hWnd
		call	ReleaseDC
		ret2	backtotrue,	backtom
	ENDM

win32_SetTimer	MACRO	backtotrue, backtom, hWnd, nIDEvent, uElapse, lpTimerFunc
		push	lpTimerFunc
		push	uElapse
		push	nIDEvent
		push	hWnd
		call	SetTimer
		ret2	backtotrue,	backtom
	ENDM

win32_KillTimer	MACRO	backtotrue, backtom, hWnd, uIDEvent
		push	uIDEvent
		push	hWnd
		call	KillTimer
		ret2	backtotrue,	backtom
	ENDM

win32_InvalidateRect	MACRO	backtotrue, backtom, hWnd, _lpRect, bErase
		push	bErase
		push	_lpRect
		push	hWnd
		call	InvalidateRect
		ret2	backtotrue,	backtom
	ENDM

win32_PolyDraw	MACRO	backtotrue, backtom, hWnd, _lppt, _lpbTypes, cCount
		push	cCount
		push	_lpbTypes
		push	_lppt
		push	hWnd
		call	PolyDraw
		ret2	backtotrue,	backtom
	ENDM

;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;	Own Macro	;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;

own32_load_bitmap_into_imagelist	MACRO	backtotrue, backtom, hInstance, lpBitmapName, himl, hbmImage, hbmMask
		win32_LoadBitmap	1, hbmImage, hInstance, lpBitmapName
		win32_ImageList_AddMasked	0, 0, himl, hbmImage, hbmMask
		win32_DeleteObject	0, 0, hbmImage
		ret2	backtotrue,	backtom
	ENDM

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;	procedure proto's	;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	WindowProcedure	PROTO	:DWORD, :DWORD, :DWORD, :DWORD

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;	initialised data	;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

.data
	application_window_title	db	"Issac test",0	; CHANGE, the title on the window. specific to window, not class
	application_window_class_name	db	"Issac test class",0	; CHANGE, name of class.

	application_frame_timer_id	dd	1	; id of the timer
	application_frame_refresh_rate	dd	16	; ? millisecond every frame
	application_frame_count	dd	0	; number of frames passed

.data?
	application_window_handle	dd	?	; stores the handle to the window for the application. created before loop
	application_handle	dd	?	; stores the handle of the application. Needed for win32 application
	application_window_class	WNDCLASSEX	<>	; stores the window class information. required only before loop though unless extra windows of this type required.
	application_window_message	MSG	<>	; stores the window message itself for the loop
	application_window_message_addr	dd	?	; stores the offset of the window message. Constantly needed, so a variable is made for it.
	application_temp_HDC	HDC	?	; stores the handle to Device Context for drawing operation
	application_temp_PAINTSTRUCT	PAINTSTRUCT	<>	; stores paintstruct from BeginPaint.

;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;	actual code	;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;

.code

start:

	;===================================================================================
	; Get the handle of the applicaton instances for later references in Win32 functions
	;===================================================================================

	win32_GetModuleHandle	1, application_handle, NULL

	;==================================================
	; Fill WNDCLASSEX structure with required variables
	;==================================================

		mov	application_window_class.cbSize,         sizeof WNDCLASSEX
			; fixed value for the function
		mov	application_window_class.style,          CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW
			; CHANGE
			; varies depending on the need of the program but usually just leave it as it is
		mov	application_window_class.lpfnWndProc,    offset	WindowProcedure
			; gives the offset of the Window Procedure loop so that the application can go into a loop for the class
		mov	application_window_class.cbClsExtra,     NULL
			; Extra Class byte: Not used.
		mov	application_window_class.cbWndExtra,     NULL
			;Extra Window byte: Not used.
		m2m	application_window_class.hInstance,      application_handle
			; handle of application instance
		mov	application_window_class.hbrBackground,  COLOR_BTNFACE+1
			; CHANGE
			; background colour of the window
		mov	application_window_class.lpszMenuName,   NULL
			; CHANGE
			; menu handle for the class
		mov	application_window_class.lpszClassName,  offset application_window_class_name
			; Name of the class, required. Change in the data section.

	win32_LoadIcon	1, application_window_class.hIcon, NULL, IDI_APPLICATION
			; CHANGE
			; the handle to an icon for the windows of this class. This is default (DEFAULT).
	win32_LoadCursor	1, application_window_class.hCursor, NULL, IDC_ARROW
			; CHANGE
			; the handle to the cursor. DEFAULT

		mov	application_window_class.hIconSm, 0
			; CHANGE
			; the handle to a small icon. eg. for display in tray. DEFAULT
			; if the icon is already in hIcon leave as 0

	;===============================================================
	; Might want to add an error check for all win32 function below.
	;===============================================================

		lea	eax, application_window_class
	win32_RegisterClassEx	0, 0, eax
			; send the pointer to the window class for registering.

	win32_CreateWindowEx	1, application_window_handle, WS_EX_OVERLAPPEDWINDOW, offset application_window_class_name, offset application_window_title, WS_OVERLAPPEDWINDOW, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, NULL, NULL, application_handle, NULL
			; CHANGE
			; Create the window from the class property.

	win32_ShowWindow	0, 0, application_window_handle, SW_SHOWNORMAL
			; Show the window after creation

	win32_UpdateWindow	0, 0, application_window_handle
			; update and draw the window

	;===================================
	; Loop until PostQuitMessage is sent
	;===================================

			lea	eax, application_window_message
			mov	application_window_message_addr, eax
			; store the message offset for use in the loop

	application_window_message_loop_start:
			; start of the loop test

		win32_GetMessage	0, 0, application_window_message_addr, NULL, 0, 0
			; 

			cmp	eax, 0
				; if the GetMessage returns WM_QUIT, equvilent to 0
			je	application_window_message_loop_end
				; end the loop by jumping out of it.

		win32_TranslateMessage	0, 0, application_window_message_addr
			; takes raw keyboard input and generates a new message (WM_CHAR) that is placed on the message queue
			; omit this call if your program doesn't process keystrokes

		win32_DispatchMessage	0, 0, application_window_message_addr
			; sends the message data to the window procedure

			jmp	application_window_message_loop_start
			; go back to the start of the loop

	application_window_message_loop_end:
			; end of the loop

		win32_ExitProcess	0, 0, application_window_message.wParam
			; call the win32 Exit process function. Terminate Process / Application

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

WindowProcedure	proc	window_handle	:DWORD,
		window_message	:DWORD,
		wParam	:DWORD,
		lParam	:DWORD

		cmp	window_message,	WM_PAINT
		je	window_message_select_WM_PAINT
		cmp	window_message,	WM_DESTROY
		je	window_message_select_WM_DESTROY
		jmp	window_message_select_default

	window_message_select_WM_PAINT:
		win32_BeginPaint	1, application_temp_HDC, window_handle, offset application_temp_PAINTSTRUCT
		win32_EndPaint	1, application_temp_HDC, window_handle, offset application_temp_PAINTSTRUCT
		return	0
			jmp	window_message_select_finished

	window_message_select_WM_DESTROY:
		win32_PostQuitMessage	0, 0, NULL
		return	0
			jmp	window_message_select_finished

	window_message_select_default:

		win32_DefWindowProc	0, 0, window_handle, window_message, wParam, lParam

	window_message_select_finished:

		ret

WindowProcedure	endp

end start